{$A+,B-,D+,E-,F-,I-,L+,N-,O-,R-,S-,V- }

(***********************************************)
(*                                             *)
(*             VIDEO60 V1.0 04/09/92           *)
(*                                             *)
(***********************************************)

Unit VIDEO60;

interface (*--------------------*)

uses Dos { ,Crt } , VdtDisp;

Type VideoResetProc = Record
       Case Integer Of
        0 : ( Proc : Procedure );
        1 : ( Ptr : Pointer );
      End;


Const VMODE_UNDEF = 0;
      VMODE_MDA   = 1;
      VMODE_CGA   = 2;
      VMODE_EGA   = 3;   { EGA ou VGA en 80x35 de car de 8x10 }
      VMODE_VGA   = 4;   { Idem EGA, mais VideoVGA=TRUE }
      VMODE_640   = 5;   { Idem EGA, mais Video640=TRUE }
                         { Mode Graphique: 640x350x16 }


      { Jeu 0 }

      MatG2B  = 0;
      MatGPlus= MatG2B+LgG2B;
      MatG0   = 32;
      MatG2   = 128;
      MatGPlus2 = MatG2+LgG2;
      MatG1   = 160;
      MatG1D  = MatG1+32;

      { Jeu 1 }

      MatGP0  = 0;
      MatGP1  = 96;
      MatGIbm = 192;

type Zn_Rec = record
                X,Y,Lg,Ht : byte;
              end;

type DtScr_Rec = record
                   case BYTE of
                     TRUE  : (Car,Att : byte);
                     FALSE : (Dt      : word);
                 end;
     MemScr_Map = array[0..35-1,0..79] of DtScr_Rec;


Var VideoEGA : Boolean;   { TRUE si VMODE_EGA }
    VideoVGA : Boolean;   { TRUE si VMODE_EGA, alors que carte VGA dtect }
    Video640 : Boolean;   { TRUE si VMODE_EGA, alors que mode graphique }
    VideoGrey: Boolean;   { TRUE si VGA gris sinon FALSE }
    VideoEGALight : Boolean;  { TRUE si EGA light }
    VideoReset : VideoResetProc;

Procedure ReducCo( How : Byte );  { reduit l'intensit }
Procedure ReducBw( How : Byte );  { n'utilisez qu'UNE fois au debut }

const CDRNORM = 1;
      CDRDOUBLE = 2;
      CDRMIXTE = 3;
      CDRMIXINV = 4;

type cadre = record
               hg,hh,hd,
               vg,   vd,
               bg,bh,bd : char;
             end;

const cdrtab : array[1..4] of cadre = (
       ( hg:'';hh:'';hd:'';
         vg:'';       vd:'';
         bg:'';bh:'';bd:'' ),
       ( hg:'';hh:'';hd:'';
         vg:'';       vd:'';
         bg:'';bh:'';bd:'' ),
       ( hg:'';hh:'';hd:'';
         vg:'';       vd:'';
         bg:'';bh:'';bd:'' ),
       ( hg:'';hh:'';hd:'';
         vg:'';       vd:'';
         bg:'';bh:'';bd:'' ) );


procedure FromScr(dest : pointer; x,y,Lg : byte);
procedure ToScr(source : pointer; x,y,Lg : byte);

Function  Ascii2Mat( CodeAttr: Word ) : Word;
procedure WrtDt( Car,x,y,attrib :byte);
procedure WrtX( Car,x,y,attrib :byte; more : Word );
procedure FillWord(var source; Lg,Data : word);
procedure RbtXY(var X,Y : byte);
procedure RbtZn(var Zn : Zn_Rec);
procedure RbtZc(var x,y,lg,ht : byte);
procedure FillZn(Zn : Zn_Rec; Car,Att : byte);
procedure FillZc(x,y,lg,ht,Car,Att : byte);
procedure ClrZn(Zn : Zn_Rec; Att : byte);
procedure ClrZc(x,y,lg,ht,Att : byte);
procedure AspZn(Zn : Zn_Rec; Att : byte);
procedure AspZc(x,y,lg,ht,Att : byte);
procedure CdrZn( Zn : Zn_Rec; Cdr : cadre; att : byte);
procedure CdrZc(x,y,lg,ht : byte; Cdr : cadre; att : byte);
procedure CCdrZn(Zn : Zn_Rec; style : byte; att : byte);
procedure CCdrZc(x,y,lg,ht : byte; style : byte; att : byte);

procedure DessWd( Zn : Zn_Rec; ZAtt,style,CAtt : byte);
procedure DessWc(x,y,lg,ht : byte; ZAtt,style,CAtt : byte);
procedure PushWd( Zn : Zn_Rec; ZAtt,style,CAtt : byte);
procedure PushWc(x,y,lg,ht : byte; ZAtt,style,CAtt : byte);
procedure PopWd;

procedure ZnUp(Zn : Zn_Rec; LineUp,Att : byte);
procedure ZcUp(x,y,lg,ht : byte; LineUp,Att : byte);
procedure ZnDn(Zn : Zn_Rec; LineDn,Att : byte);
procedure ZcDn(x,y,lg,ht : byte; LineDn,Att : byte);
procedure CurXY(X,Y : byte);
(*
procedure CurFormat(Deb,Fin : byte);
*)
function GetVideoMode : byte;
procedure SetVideoMode(what : byte);
function GetVideoCarte : byte;
function GetAdrScr : pointer;
function GetBestVideoMode : byte;
procedure WrtScr(texte : string; X,Y,Att : byte);

procedure PushZn(Zn : Zn_Rec);
procedure PushZc(x,y,lg,ht : byte);
procedure PopZn;
procedure PopNoZn;

const MX_FILE_ZN = 40;
type FileZone = record
                  open : boolean;
                  Zn : Zn_Rec;
                  AdrExt : Pointer;
                  case WORD of
                    TRUE : (ofs,seg : word);
                    FALSE : (Adr : pointer);
                end;

var FileZn : array[1..MX_FILE_ZN] of FileZone;

procedure CloseZn(NumFich : byte);
function SaveZn(Zn : Zn_Rec) : byte;
function SaveZc(x,y,lg,ht : byte) : byte;
procedure RstZn(NumFich : byte);
procedure RstZnTo(NumFich,x,y : byte);

Function  OpenVideoSys( VMode : Byte; neige, Grey, EGALight : boolean) : Byte;
procedure CloseVideoSys;

Procedure CurOFF;
Procedure CurON;
(*
Procedure CurSmall;
Procedure CurBig;
*)
Procedure CurPos( column, row : Byte );

Procedure KeepVideo;
Procedure ResumeVideo( Grey, EGALight : Boolean );

Procedure FixPalCoVGA;
Procedure FixPalBWVGA;

Procedure LoadMatrice( Var Jeu; LgJeu : Word; Table : Byte; Ascii : Word );
Procedure CallVideoResetProc( Proc : VideoResetProc );
Procedure ResetVideoEGA;

Procedure VideoSynchro( C18 : LongInt );

implementation (*------------------------*)

Const
      INTVIDEO    = $10;

      VIDEOSTAT   = $3DA;

var LastVideoMode : byte;
    VideoMode     : Byte;
    LastHiMat     : Word;



    ScrSnow  : boolean;

    ScreenHt : Byte;     { 25 ou 35 }
    ScreenSeg: Word;

type _VMat_ = Array[0..511] Of MinMatrice;

var
    _VirtualScreen_ : Pointer;       { Memoire de l'ecran 80x35x2 (+15) }
    _VirtualExt_    : Pointer;       { Extension de l'ecran 80x35x2 (+15) }
    _VirtualMatrice_ : ^_VMat_;      { Memoire reel Matrice 512x10 }
    _VExt_           : Word;         { Segment de _VirtualExt_ }
    _VCurX_          : Byte;         { Position Virtuel du curseur }
    _VCurY_          : Byte;         { idem... Y }
    _VCurFlash_      : Boolean;
    _VCurFlash_C18   : LongInt;
    MasqueCurseur    : Boolean;


{******** Special EGA/VGA **********}

Type RGB = Record
       Red, Green, Blue : Byte;
      End;

Const

      CNoir    = 0;

      CBleu    = 1;       { couleurs du minitel : }
      CRouge   = 2;       { ce peut tre des nuances de gris... }
      CMagenta = 3;
      CVert    = 4;
      CCyan    = 5;
      CJaune   = 6;

      CBlanc   = 7;


      PalCoEGA : Array[0..16] Of Byte = (0,9,12,13,10,11,14,15,0,9,12,13,10,11,14,15,0);

      PalCoEGA2 : Array[0..16] Of Byte = (0,1,4,5,2,3,6,7,0,1,4,5,2,3,6,7,0);

      PalCoVGA : Array[0..16] Of Byte = (0,1,2,3,4,5,6,7,0,1,2,3,4,5,6,7,0);

      { noir & blanc pour VGA only }

      PalBwVGA : Array[0..16] Of Byte = (0,8,9,10,11,12,13,14,0,8,9,10,11,12,13,14,0);

      LgDAC = 15;

      DAC   : Array[0..LgDAC-1] Of RGB = (
         ( Red:$00; Green:$00; Blue:$00 ),     { noir }

         ( Red:$15; Green:$15; Blue:$3F ),     { bleu/min }
         ( Red:$3F; Green:$15; Blue:$15 ),     { rouge/min }
         ( Red:$3F; Green:$15; Blue:$3F ),     { magenta/min }
         ( Red:$15; Green:$3F; Blue:$15 ),     { vert/min }
         ( Red:$15; Green:$3F; Blue:$3F ),     { cyan/min  }
         ( Red:$3F; Green:$3F; Blue:$15 ),     { jaune/min }
         ( Red:$3F; Green:$3F; Blue:$3F ),     { blanc }

         ( Red:$19; Green:$19; Blue:$19 ),     { bleu/gris }
         ( Red:$21; Green:$21; Blue:$21 ),     { rouge/gris }
         ( Red:$26; Green:$26; Blue:$26 ),     { magenta/gris }
         ( Red:$2D; Green:$2D; Blue:$2D ),     { vert/gris }
         ( Red:$32; Green:$32; Blue:$32 ),     { cyan/gris  }
         ( Red:$3A; Green:$3A; Blue:$3A ),     { jaune/gris }
         ( Red:$3F; Green:$3F; Blue:$3F )      { blanc }
        );


Procedure ReducCo( How : Byte ); Assembler;
Asm
    MOV  SI, (OFFSET DAC)+3
    MOV  CX, 3*7
    MOV  AL, [How]
    CLD
@BOUCLE:
    SUB  [SI], AL
    INC  SI
    LOOP @BOUCLE
End;

Procedure ReducBw( How : Byte ); Assembler;
Asm
    MOV  SI, (OFFSET DAC)+3*8
    MOV  CX, 3*7
    MOV  AL, [How]
    CLD
@BOUCLE:
    SUB  [SI], AL
    INC  SI
    LOOP @BOUCLE
End;


Procedure NewDAC; Assembler;
Asm
    MOV  AX, 1012h
    XOR  BX, BX
    MOV  CX, LgDAC
    MOV  DX, SEG DAC
    MOV  ES, DX
    MOV  DX, OFFSET DAC
    INT  INTVIDEO
End;


Procedure FixPalCoEGA; Assembler;
Asm
    MOV  [VideoGrey], FALSE
    MOV  [VideoEGALight], FALSE
    MOV  AX, 1002h
    MOV  DX, SEG PalCoEGA
    MOV  ES, DX
    MOV  DX, OFFSET PalCoEGA
    INT  INTVIDEO
End;


Procedure FixPalCoEGALight; Assembler;
Asm
    MOV  [VideoGrey], FALSE
    MOV  [VideoEGALight], TRUE
    MOV  AX, 1002h
    MOV  DX, SEG PalCoEGA2
    MOV  ES, DX
    MOV  DX, OFFSET PalCoEGA2
    INT  INTVIDEO
End;



Procedure FixPalCoVGA; Assembler;
Asm
    MOV  [VideoGrey], FALSE
    MOV  AX, 1002h
    MOV  DX, SEG PalCoVGA
    MOV  ES, DX
    MOV  DX, OFFSET PalCoVGA
    INT  INTVIDEO
End;


{ VGA seulement }

Procedure FixPalBWVGA; Assembler;
Asm
    MOV  [VideoGrey], TRUE
    MOV  AX, 1002h
    MOV  DX, SEG PalBWVGA
    MOV  ES, DX
    MOV  DX, OFFSET PalBWVGA
    INT  INTVIDEO
End;




Procedure OpenVideoEGA; Assembler;
Asm
(*
   MOV  AH, 0Fh
   INT  INTVIDEO
   MOV  [LastVideoMode], AL
*)
   PUSH BP

   MOV  AX, 1130h
   MOV  BH, 00h
   INT  INTVIDEO
   MOV  [LastHiMat], CX

   POP  BP

   MOV  AX, 1201h          { 350 lignes }
   MOV  BL, 30h
   INT  INTVIDEO

   MOV  AX, 0003h          { Couleur 80x25 }
   INT  INTVIDEO

End;


Procedure CloseVideoEGA; Assembler;
Asm
   MOV  AL, [BYTE PTR LastHiMat]
   CMP  AL, 14
   JNE  @01
   MOV  AL, 1
   JMP  @OK
@01:
   CMP  AL, 8
   JNE  @02
   MOV  AL, 0
   JMP  @OK
@02:
   MOV  AL, 2
@OK:
   MOV  AH, 12h
   MOV  BL, 30h
   INT  INTVIDEO

   MOV  AH, 00h
   MOV  AL, [LastVideoMode]
   INT  INTVIDEO
End;



{******** 640 *********}

Procedure WC640( xc, yc : Word; var mat; trait, fond : Word; more : Word );
var ofs : Word;
Begin

 ofs := xc+(yc*(10*(640 Div 8)));
 asm
     push ds
     push es
     push si
     mov ax, $A000
     mov es, ax
     mov bx, [ofs]
     mov dx, $03CE
     mov ax, $0205
     out dx, ax		{ Mode Write 2 }
     mov ax, $0003
     out dx, ax		{ Mode Replace }
     mov cl, 10
     lds si, [mat]
     cld
@boucle:
     mov ax, $0003
     out dx, ax		{ Mode Replace }
     mov ax, $FF08
     out dx, ax  	{ Masque de bits }
     mov al, BYTE PTR[fond]
     mov [es:bx], al	{ ecrire FOND global }
     mov al, [es:bx]

     mov ax, $0003
     out dx, ax		{ Mode Replace }
     cmp cl, 1
     jne @normal
     test [more], 128
     jz  @normal
     mov ah, $FF
     jmp @ici
@normal:
     lodsb
     xchg al, ah
@ici:
     mov al, $08
     out dx, ax
     mov al, BYTE PTR[trait]
     mov [es:bx], al	{ ecrire TRAIT... }

     dec cl
     jz @fin
     add bx, (640 / 8)
     jmp @boucle
@fin:
     pop si
     pop es
     pop ds
 end;
End;


Var CurrentDevMat : ^MinMatrice;        { Matrice actuellement developp... }
                                        { + rapide si deja presente... }
    CurrentMode   : Word;

    RamDevMat : Array[0..3] Of MinMatrice;

{ attr :    xxxx                                }
{           ^-^^                                }
{           | |horiz 8=>16                      }
{           | verti 10=>20                      }
{           element a retourner 0, 1, 2, 3      }
{                                               }
{ 0          0|1                                }
{ -          -|-                                }
{ 1   0|1    2|3                                }

Function MatDev( Var mat : MinMatrice; attr : Word ) : PMinMatrice;
Var i : Word;
    w : Word;
    s : Word;
    d : Word;
Begin
 If (CurrentDevMat<>@mat) Or (CurrentMode<>(attr And 3)) Then
  Begin
   If ((attr And 1)<>0) Then
    Begin
     { horiz 8=>16 bits }
     w := 0;
     For i := 0 To 9 Do
      Begin
       s := mat[i];
       Asm
           xor dx, dx
           mov al, BYTE PTR [s]
           mov cl, 8
@boucle:
           ror al, 1
           rcr dx, 1
           rol al, 1
           rcr dx, 1
           ror al, 1
           dec cl
           jnz @boucle
           mov [d], dx
       End;
       If ((attr And 2)<>0) Then
        Begin
         If (i<5) Then
          Begin
           RamDevMat[0,w] := hi(d);
           RamDevMat[1,w] := lo(d);
           Inc(w);
           RamDevMat[0,w] := hi(d);
           RamDevMat[1,w] := lo(d);
           Inc(w);
          End
         Else
          Begin
           If (i=5) Then w := 0;
           RamDevMat[2,w] := hi(d);
           RamDevMat[3,w] := lo(d);
           Inc(w);
           RamDevMat[2,w] := hi(d);
           RamDevMat[3,w] := lo(d);
           Inc(w);
          End;
        End
       Else
        Begin
         RamDevMat[0,i] := hi(d);
         RamDevMat[1,i] := lo(d);
        End;
      End;
     CurrentDevMat := @mat;
     CurrentMode := attr And 3;
    End
   Else
    If ((attr And 2)<>0) Then
     Begin
      { verti 10=>20 bits }
      w := 0;
      For i := 0 To 9 Do
       Begin
        If (i<5) Then
         Begin
          RamDevMat[0,w] := mat[i];
          Inc(w);
          RamDevMat[0,w] := mat[i];
          Inc(w);
         End
        Else
         Begin
          If (i=5) Then w := 0;
          RamDevMat[1,w] := mat[i];
          Inc(w);
          RamDevMat[1,w] := mat[i];
          Inc(w);
         End;
       End;
      CurrentDevMat := @mat;
      CurrentMode := attr And 3;
     End
    Else
     Begin
      MatDev := @mat;   { renvoi la matrice courante... }
     End;
  End;
 MatDev := @RamDevMat[(attr shr 2) And 3];
End;



Procedure Cur640( curon : Boolean );
Var z : ^Word;
    RC : Word;
    attrib : Byte;
    decal : Word;
    w : ^Word;
    mat : PMinMatrice;
Begin
 decal := (_VCurX_+(_VCurY_*80))*2;
 z := ptr(ScreenSeg,decal);
 attrib := Hi(z^);
 RC := Byte(z^)+((attrib And 8)shl 5);

 If curon Then
  Begin
   If Not(MasqueCurseur) Then
    Begin
  {   If (attrib And 7)=0 Then attrib := 7; }
     WC640(_VCurX_,_VCurY_,_VirtualMatrice_^[32,0],0,(attrib And 7),0);
    End;
  End
 Else
  Begin
   w := Ptr(_VExt_,decal);
   mat := @_VirtualMatrice_^[RC,0];
   If (w^ And 3)<>0 Then mat := MatDev(mat^,w^);
   WC640(_VCurX_,_VCurY_,mat^,(attrib And 7),((attrib shr 4) And 7),w^);
  End;

 _VCurFlash_ := curon;
{ _VCurFlash_C18 := -1; }
End;

Procedure CurOn;
Begin
 If Video640 Then
  Begin
   MasqueCurseur := FALSE;
   Cur640(TRUE);
  End;
End;

Procedure CurOff;
Begin
 If Video640 Then
  Begin
   MasqueCurseur := TRUE;
   Cur640(FALSE);
  End;
End;


Procedure VideoSynchro( C18 : LongInt );
Begin
 If (Video640) Then
  Begin
   If (_VCurFlash_C18<0) Then _VCurFlash_C18 := C18
   Else
    If ((C18-_VCurFlash_C18)>=3) Then
     Begin
      Cur640(Not(_VCurFlash_));
      _VCurFlash_C18 := C18;
     End;
  End;
End;


Procedure Wrt640( decal : Word; x, y, len : Byte );
Var z : ^Word;
    w : ^Word;
    i : Word;
    RC : Word;
    attrib : Byte;
    mat : PMinMatrice;
Begin
 If Video640 Then
  Begin
   z := ptr(ScreenSeg,decal);
   w := ptr(_VExt_,decal);
   For i := 1 To len Do
    Begin
     attrib := Hi(z^);
     RC := Byte(z^)+((attrib And 8)shl 5);
     mat := @_VirtualMatrice_^[RC,0];
     If (w^ And 3)<>0 Then mat := MatDev(mat^,w^);
     WC640(x,y,mat^,(attrib And 7),((attrib shr 4) And 7),w^);
     Inc(Word(z),2);
     Inc(x);
    End;
  End;
End;


Procedure RefreshJeu( LgJeu : Word; Table : Byte; Ascii : Word );
Var MemScr : ^MemScr_Map; { ecran actif      }
    x, y   : Word;
    c      : ^DtScr_Rec;
    decal  : Word;
Begin
 Table := (Table And 1) Shl 3;
 MemScr := Ptr(ScreenSeg,0);
 decal := 0;
 For y:=0 To 34 Do
  Begin
   c := @MemScr^[y,0];
   For x:=0 To 79 Do
    Begin
     If ((c^.Att And 8)=Table) And (c^.Car>=Ascii) And (c^.Car<Ascii+LgJeu) Then
      Begin
       Wrt640(decal,x,y,1);
       If (_VCurX_=x) And (_VCurY_=y) Then Cur640(TRUE);
      End;
     Inc(Word(c),2);
     Inc(decal,2);
    End;
  End;
End;


Const SeqParms1 : Array[0..3] Of Word = ($0100,$0402,$0704,$0300);
      GCParms1  : Array[0..2] Of Word = ($0204,$0005,$0006);

Procedure GenModeSet; Assembler;
Asm
        cli
        mov dx, 3C4h
        mov si, OFFSET SeqParms1
        mov cx, 4
        cld
@L01:
        lodsw
        out dx, ax
        loop @L01
        sti

        mov dl, 0CEh
        mov si, OFFSET GCParms1
        mov cx, 3
@L02:
        lodsw
        out dx, ax
        loop @L02
End;



Const SeqParms2 : Array[0..3] Of Word = ($0100,$0302,$0304,$0300);
      GCParms2  : Array[0..2] Of Word = ($0004,$1005,$0E06);

Procedure GenModeClear; Assembler;
Asm
        cli
        mov dx, 3C4h
        mov si, OFFSET SeqParms2
        mov cx, 4
        cld
@L01:
        lodsw
        out dx, ax
        loop @L01
        sti

        mov dl, 0CEh
        mov si, OFFSET GCParms2
        mov cx, 3
@L02:
        lodsw
        out dx, ax
        loop @L02
End;


Procedure LoadMatrice( Var Jeu; LgJeu : Word; Table : Byte; Ascii : Word );
Var Ofs : Word;
    kk  : Array[0..30000] Of Byte Absolute Jeu;
    i, j, n : Word;
Begin
 If (Video640) Then
  Begin
   CurrentDevMat := Nil;        { annule effet }
   Move(Jeu,_VirtualMatrice_^[Ascii+(256*Table),0],LgJeu*10);
   RefreshJeu(LgJeu,Table,Ascii);
  End
 Else
  Begin
   Ofs := (Table*(512*32))+Ascii*32;
   GenModeSet;

   n := 0;
   For i:=1 To LgJeu Do
    Begin
     For j := 0 To 9 Do
      Begin
       mem[$A000:Ofs] := kk[n];
       Inc(n);
       Inc(Ofs);
      End;
     Inc(Ofs,22);
    End;

   GenModeClear;
  End;
End;


Procedure LoadMatrice2( Var Jeu; LgJeu : Word; Table : Byte; Ascii : Word ); Assembler;
Asm
    PUSH BP

    MOV  BH, 10
    MOV  BL, [Table]
    MOV  CX, [LgJeu]
    MOV  DX, [Ascii]
    MOV  ES, [WORD PTR Jeu+2]
    MOV  BP, [WORD PTR Jeu]
    MOV  AX, 1100h
    INT  INTVIDEO

    POP  BP
End;


Procedure CallVideoResetProc( Proc : VideoResetProc );
Begin
 If Proc.Ptr<>NIL Then Proc.Proc;
End;


Procedure ResetPalette; Assembler;
Asm
    { Remettre en place la palette ... }

    CMP  [VideoVGA], FALSE
    JE   @PALEGA
    CALL NewDAC
    CMP  [VideoGrey], FALSE
    JE   @PALVGA
    CALL FixPalBWVGA
    JMP  @FIN
@PALVGA:
    CALL FixPalCoVGA
    JMP  @FIN
@PALEGA:
    CMP  [VideoEGALight], FALSE
    JE   @FixPalCoEGA
    CALL FixPalCoEGALight
@FixPalCoEGA:
    CALL FixPalCoEGA
@FIN:
    MOV  AX, [WORD PTR VideoReset+2]
    PUSH AX
    MOV  AX, [WORD PTR VideoReset]
    PUSH AX
    CALL CallVideoResetProc
End;


Procedure ResetCRTC_EGA; Assembler;
Asm
    { Lecture etat curseur }

    MOV  AH, 03h
    MOV  BH, 00h
    INT  INTVIDEO

    PUSH DX           { sauve position du curseur }

    PUSH BP

    MOV  BH, 10
    XOR  BL, BL
    MOV  CX, 1          { 0 => BUG SUR CERTAINES CARTES!!! }
    MOV  DX, 0
    MOV  AX, DS
    MOV  ES, AX
    MOV  BP, OFFSET JeuG2B
    MOV  AX, 1110h
    INT  INTVIDEO

    POP  BP

    { Pour Ci-dessus: Peu importe ce qu'on tlcharge... }
    { c'est juste a cause d'un bug de certaines cartes... }

    { Fixer le bit7=clignotement }
    MOV  AX, 1003h
    MOV  BL, 1
    INT  INTVIDEO

    { Fixer Attribut video: bit3=0 jeu 0, bit3=1 jeu 1 }
    MOV  AX, 1103h
    MOV  BL, 00000100b
    INT  INTVIDEO

    { Emulation OFF }

    MOV  AX, 1201h
    MOV  BL, 34h
    INT  INTVIDEO

    { Cursor BIG }

    MOV  AH, 01h
    MOV  CH, 0
    MOV  CL, 9
    INT  INTVIDEO

    { Emulation ON }

    MOV  AX, 1200h
    MOV  BL, 34h
    INT  INTVIDEO

    { Restaure la position du curseur }

    POP  DX
    MOV  AH, 02h
    MOV  BH, 00h
    INT  INTVIDEO

End;

(*
Procedure EmulOff; Assembler;
Asm
    MOV  AX, 1201h
    MOV  BL, 34h
    INT  INTVIDEO
End;
*)

Procedure CursorBig; Assembler;
Asm
    CMP  [Video640], FALSE
    JNE  @@EXIT
    MOV  AH, 01h
    MOV  CH, 0
    MOV  CL, 9
    INT  INTVIDEO
@@EXIT:
End;

(*
Procedure EgaCursorBig; Assembler;
Asm
    MOV  AX, 1201h
    MOV  BL, 34h
    INT  INTVIDEO      { Emule cur off }

    MOV  AH, 01h
    MOV  CH, 0
    MOV  CL, 9
    INT  INTVIDEO

    MOV  AX, 1200h
    MOV  BL, 34h
    INT  INTVIDEO      { Emule cur on }
End;
*)

Const
      LgGPlus = 11;

      JeuGPlus : Array[0..LgGPlus-1] Of MinMatrice = (
        (  0,126, 66, 66, 90, 90, 66, 66,126,  0),
        (  0, 16,  0, 16,  8,  4, 68, 56,  0,  0),
        (  0,  0,  0,  0, 24,  0,  0,  0,  0,  0),
        ( 34,136, 34,136, 34,136, 34,136, 34,136),
        (  0,  0, 24, 60,102,102, 60, 24,  0,  0),
        (  0,127,106, 85,106, 85,106, 85,127,  0),
        (  0,254,170, 86,170, 86,170, 86,254,  0),
        ( 16, 24,252,254,255,254,252, 24, 16,  0),
        (  8, 24, 63,127,255,127, 63, 24,  8,  0),
        ( 16, 56,124,254, 56, 56, 56, 56, 56, 56),
        ( 56, 56, 56, 56, 56, 56,254,124, 56, 16)
        );


      LgGPlus2 = 1;

      JeuGPlus2 : Array[0..LgGPlus2-1] Of MinMatrice = (
        ( 24,153, 90, 60,231,231, 60, 90,153, 24)
        );


      LgGIbm = 44;

      JeuGIbm : Array[0..LgGIbm-1] Of MinMatrice = (
        ( 16, 16, 16, 16,240, 16, 16, 16, 16, 16),
        ( 16, 16, 16,240, 16,240, 16, 16, 16, 16),
        ( 40, 40, 40, 40,232, 40, 40, 40, 40, 40),
        (  0,  0,  0,  0,248, 40, 40, 40, 40, 40),
        (  0,  0,  0,240, 16,240, 16, 16, 16, 16),
        ( 40, 40, 40,232,  8,232, 40, 40, 40, 40),
        ( 40, 40, 40, 40, 40, 40, 40, 40, 40, 40),
        (  0,  0,  0,248,  8,232, 40, 40, 40, 40),
        ( 40, 40, 40,232,  8,248,  0,  0,  0,  0),
        ( 40, 40, 40, 40,248,  0,  0,  0,  0,  0),
        ( 16, 16, 16,240, 16,240,  0,  0,  0,  0),
        (  0,  0,  0,  0,240, 16, 16, 16, 16, 16),
        ( 16, 16, 16, 16, 31,  0,  0,  0,  0,  0),
        ( 16, 16, 16, 16,255,  0,  0,  0,  0,  0),
        (  0,  0,  0,  0,255, 16, 16, 16, 16, 16),
        ( 16, 16, 16, 16, 31, 16, 16, 16, 16, 16),
        (  0,  0,  0,  0,255,  0,  0,  0,  0,  0),
        ( 16, 16, 16, 16,255, 16, 16, 16, 16, 16),
        ( 16, 16, 16, 31, 16, 31, 16, 16, 16, 16),
        ( 40, 40, 40, 40, 47, 40, 40, 40, 40, 40),
        ( 40, 40, 40, 47, 32, 63,  0,  0,  0,  0),
        (  0,  0,  0, 63, 32, 47, 40, 40, 40, 40),
        ( 40, 40, 40,239,  0,255,  0,  0,  0,  0),
        (  0,  0,  0,255,  0,239, 40, 40, 40, 40),
        ( 40, 40, 40, 47, 32, 47, 40, 40, 40, 40),
        (  0,  0,  0,255,  0,255,  0,  0,  0,  0),
        ( 40, 40, 40,239,  0,239, 40, 40, 40, 40),
        ( 16, 16, 16,255,  0,255,  0,  0,  0,  0),
        ( 40, 40, 40, 40,255,  0,  0,  0,  0,  0),
        (  0,  0,  0,255,  0,255, 16, 16, 16, 16),
        (  0,  0,  0,  0,255, 40, 40, 40, 40, 40),
        ( 40, 40, 40, 40, 63,  0,  0,  0,  0,  0),
        ( 16, 16, 16, 31, 16, 31,  0,  0,  0,  0),
        (  0,  0,  0, 31, 16, 31, 16, 16, 16, 16),
        (  0,  0,  0,  0, 63, 40, 40, 40, 40, 40),
        ( 40, 40, 40, 40,255, 40, 40, 40, 40, 40),
        ( 16, 16, 16,255, 16,255, 16, 16, 16, 16),
        ( 16, 16, 16, 16,240,  0,  0,  0,  0,  0),
        (  0,  0,  0,  0, 31, 16, 16, 16, 16, 16),
        (255,255,255,255,255,255,255,255,255,255),
        (  0,  0,  0,  0,  0,255,255,255,255,255),
        (240,240,240,240,240,240,240,240,240,240),
        ( 15, 15, 15, 15, 15, 15, 15, 15, 15, 15),
        (255,255,255,255,255,  0,  0,  0,  0,  0)
       );


      LgG1 = 64;

(*
Procedure DirectVideo( Code : Char; x, y, Attr : Byte ); Assembler;
Asm
    MOV DL, [y]
    XOR DH, DH
    MOV AX, DX
    MOV CL, 7
    SHL AX, CL
    MOV CL, 5
    SHL DX, CL
    ADD AX, DX
    MOV BL, [x]
    SHL BL, 1
    ADD AL, BL
    ADC AH, 0

    MOV DI, AX
    MOV AX, 0B800h
    MOV ES, AX
    MOV AL, [Code]
    MOV AH, [Attr]
    MOV [ES:DI], AX
End;
*)

Const
      (*
      MatGIbm = 64;
      *)

      UnkMat  = MatGPlus+1;

      Inf20hMat : Array[0..31] Of Byte =
       (UnkMat,UnkMat,UnkMat,UnkMat,UnkMat,UnkMat,UnkMat,UnkMat,
        UnkMat,MatGPlus+4,UnkMat,MatGPlus+5,MatGPlus+6,UnkMat,UnkMat,MatGPlus2+0,
        MatGPlus+7,MatGPlus+8,UnkMat,UnkMat,UnkMat,MatG2+4,UnkMat,UnkMat,
        MatG2+6,MatG2+8,MatG2+7,MatG2+5,UnkMat,UnkMat,MatGPlus+9,MatGPlus+10);

      LgSup7FhMat = 52;
      Sup7FhMat : Array[0..LgSup7FhMat-1] Of Byte =
       (MatG0+$23,MatG2B+19,MatG2B+6,MatG2B+10,MatG2B+15,MatG2B+0,MatG0+$41,MatG2B+20,
        MatG2B+11,MatG2B+16,MatG2B+1,MatG2B+17,MatG2B+12,MatG2B+2,MatG0+$21,MatG0+$21,
        MatG0+$25,MatG2+16,MatG2+15,MatG2B+13,MatG2B+18,MatG2B+3,MatG2B+14,MatG2B+4,
        MatG0+$59,MatG2B+18,MatG2B+19,UnkMat,MatG2+1,UnkMat,UnkMat,UnkMat,
        MatG2B+5,MatG2B+7,MatG2B+8,MatG2B+9,UnkMat,UnkMat,UnkMat,UnkMat,
        UnkMat,UnkMat,UnkMat,MatG2+13,MatG2+12,UnkMat,UnkMat,UnkMat,
        MatGPlus+3,UnkMat,UnkMat,MatG0+$5C);




Procedure LoadMatriceG1Joint;
Var Mat : MinMatrice;
    Jeu : Array[0..(LgG1 Div 2)-1] Of MinMatrice;
    x   : Byte;
    i   : Byte;
    gra : Byte;
Begin
 For gra := 0 To (LgG1 Div 2)-1 Do
  Begin
   x := ((gra Shr 1) And 1)*15+(gra And 1)*240;
   For i := 0 To 2 Do Mat[i] := x;

   x := ((gra Shr 3) And 1)*15+((gra Shr 2) And 1)*240;

   For i := 3 To 6 Do Mat[i] := x;

   x := ((gra Shr 5) And 1)*15+((gra Shr 4) And 1)*240;

   For i := 7 To 9 Do Mat[i] := x;

   Jeu[gra] := Mat;
  End;
 LoadMatrice(Jeu,LgG1 Div 2,0,MatG1);
End;


Procedure LoadMatriceG1Disjoint;
Var Mat : MinMatrice;
    Jeu : Array[0..LgG1-1] Of MinMatrice;
    x   : Byte;
    i   : Byte;
    gra : Byte;
Begin
 For gra := 0 To LgG1-1 Do
  Begin
   x := ((gra Shr 1) And 1)*15+(gra And 1)*240;
   For i := 0 To 2 Do Mat[i] := x;

   x := ((gra Shr 3) And 1)*15+((gra Shr 2) And 1)*240;

   For i := 3 To 6 Do Mat[i] := x;

   x := ((gra Shr 5) And 1)*15+((gra Shr 4) And 1)*240;

   For i := 7 To 9 Do Mat[i] := x;

   Mat[0] := Mat[0] And Not(128+8);
   Mat[1] := Mat[1] And Not(128+8);
   Mat[2] := 0;
   Mat[3] := Mat[3] And Not(128+8);
   Mat[4] := Mat[4] And Not(128+8);
   Mat[5] := Mat[5] And Not(128+8);
   Mat[6] := 0;
   Mat[7] := Mat[7] And Not(128+8);
   Mat[8] := Mat[8] And Not(128+8);
   Mat[9] := 0;

   Jeu[gra] := Mat;
  End;
 LoadMatrice(Jeu,LgG1,0,MatG1D);
End;

(*
Procedure InEGAMem( CodeAttr, Decal : Word ); Assembler;
Asm
    PUSH BX
    PUSH DS

    MOV  AX, SEG @DATA
    MOV  DS, AX

    CMP  [VideoEGA], FALSE
    JNE  @WRITE
    MOV  AX, [CodeAttr]
    JMP  @EXIT
@WRITE:
    MOV  AX, [CodeAttr]
    MOV  DS, [EgaSeg]
    MOV  BX, [Decal]
    MOV  [BX], AX
@EXIT:
    POP  DS
    POP  BX
End;


Procedure WrtEGAMem( Car, x, y, Attr : Byte ); Assembler;
Asm
    MOV  BL, [x]
    CMP  BL, 80
    JAE  @FIN
    MOV  AL, [y]
    CMP  AL, [ScreenHt]
    JAE  @FIN

    XOR  AH, AH
    MOV  DX, AX
    MOV  CL, 6
    SHL  AX, CL
    MOV  CL, 4
    SHL  DX, CL
    ADD  AX, DX

    XOR  BH, BH
    ADD  BX, AX
    SHL  BX, 1
    MOV  AL, [Car]
    MOV  AH, [Attrib]
    PUSH AX
    PUSH BX
    CALL InEGAMem
@FIN:
End;
*)

Function  Ascii2Mat( CodeAttr : Word ) : Word; Assembler;
Asm
    PUSH BX
    PUSH DS

    MOV  AX, SEG @DATA
    MOV  DS, AX

    CMP  [VideoEGA], FALSE
    JNE  @TRADTHIS
    MOV  AX, [CodeAttr]
    AND  AH, 127
    JMP  @EXIT
@TRADTHIS:
    MOV  AX, [CodeAttr]
    TEST AH, 128
    JZ   @VRAIMENT
    XOR  AH, 128         { bit7=0 }
    JMP  @EXIT
@VRAIMENT:
    CMP  AL, 20h
    JB   @INF20h
    CMP  AL, 7Fh
    JA   @SUP7Fh
    (*
    SUB  AL, 20h
    *)
    JMP  @JEU0

@INF20h:
    MOV  BX, OFFSET Inf20hMat
    XLAT
    JMP  @JEU0
@SUP7Fh:
    CMP  AL, 80h+LgSup7FhMat
    JAE  @SUP7Fh2
    SUB  AL, 80h
    MOV  BX, OFFSET Sup7FhMat
    XLAT
    JMP  @JEU0
@SUP7Fh2:
    CMP  AL, 0E0h
    JAE  @SUP7Fh3
    SUB  AL, 0B4h
    ADD  AL, MatGIbm
@JEU1:
    MOV  AH, [BYTE PTR CodeAttr+1]
    OR   AH, 00001000b    { bit3  1 }
    JMP  @EXIT
@SUP7Fh3:
    CMP  AL, ''
    JNE  @001
    MOV  AL, MatG2+17
    JMP  @JEU0
@001:
    CMP  AL, ''
    JNE  @002
    MOV  AL, MatG2+4
    JMP  @JEU0
@002:
    CMP  AL, ''
    JNE  @003
    MOV  AL, MatG2+14
    JMP  @JEU0
@003:
    CMP  AL, ''
    JNE  @004
    MOV  AL, MatGPlus+0
    JMP  @JEU0
@004:
    CMP  AL, ''
    JNE  @005
    MOV  AL, MatG2+10
    JMP  @JEU0
@005:
    CMP  AL, ''
    JNE  @006
    MOV  AL, MatG2+11
    JMP  @JEU0
@006:
    CMP  AL, ''
    JNE  @007
    MOV  AL, MatG2+9
    JMP  @JEU0
@007:
    CMP  AL, ''
    JNE  @008
    MOV  AL, MatGPlus+2
    JMP  @JEU0
@008:
    MOV  AL, UnkMat
@JEU0:
    MOV  AH, [BYTE PTR CodeAttr+1]
    AND  AH, 11110111b    { bit3  0 }
@EXIT:
    POP  DS
    POP  BX
End;



{******** Fin EGA/VGA ***********}

Function _WrtDt_( Car, x, y, attrib : Byte) : Word; Assembler;
Asm
    XOR  AX, AX
    MOV  BL, [x]
    CMP  BL, 80
    JAE  @FIN
    MOV  AL, [y]
    CMP  AL, [ScreenHt]
    JAE  @FIN

    XOR  AH, AH
    MOV  DX, AX
    MOV  CL, 6
    SHL  AX, CL
    MOV  CL, 4
    SHL  DX, CL
    ADD  AX, DX

    XOR  BH, BH
    ADD  BX, AX
    SHL  BX, 1
    MOV  ES, [ScreenSeg]
    MOV  AL, [Car]
    MOV  AH, [Attrib]
    PUSH AX
    CALL Ascii2Mat
    CMP  [ScrSnow], FALSE
    JE   @@NOSNOW
    MOV  DX, VIDEOSTAT
    MOV  CL, AL         { sauve }
@@CF1:
    IN   AL, DX
    RCR  AL, 1
    JC   @@CF1
@@CF0:
    IN   AL, DX
    RCR  AL, 1
    JNC  @@CF0
    MOV  AL, CL         { restore }
@@NOSNOW:
    MOV  [ES:BX], AX
    MOV  AX, BX
@FIN:
End;


Procedure WrtDt( Car, x, y, attrib : Byte);
var decal : Word;
Begin
 decal := _WrtDt_(Car,x,y,attrib);
 If (Video640) Then
  Begin
   Word(Ptr(_VExt_,decal)^) := 0;       { RAZ }
   Wrt640(decal,x,y,1);
   If (_VCurX_=x) And (_VCurY_=y) Then Cur640(TRUE);
  End;
End;


Procedure WrtX( Car, x, y, attrib : Byte; more : Word );
var decal : Word;
Begin
 decal := _WrtDt_(Car,x,y,attrib);
 if (Video640) Then
  Begin
   Word(Ptr(_VExt_,decal)^) := more;
   Wrt640(decal,x,y,1);
   If (_VCurX_=x) And (_VCurY_=y) Then Cur640(TRUE);
  End;
End;


Function _WrtScr_(texte : string; X,Y,Att : byte) : Word; Assembler;
Asm
    push ds

    MOV  BL, [x]
    CMP  BL, 80
    JAE  @@FIN_1
    MOV  AL, [y]
    CMP  AL, [ScreenHt]
    JB   @@CONTX
@@FIN_1:
    XOR  AX, AX
    JMP  @@FIN_2
@@CONTX:
    XOR  AH, AH
    MOV  DX, AX
    MOV  CL, 6
    SHL  AX, CL
    MOV  CL, 4
    SHL  DX, CL
    ADD  AX, DX

    XOR  BH, BH
    ADD  AX, BX
    SHL  AX, 1
    MOV  DI, AX
    PUSH AX             { <==== SAUVE AX }
    MOV  ES, [ScreenSeg]

    mov  cl, 80
    sub  cl, [X]       { nombre de car a envoye maximun!! }
                       { dans cl }
    mov  ah, [Att]     { range attrib a diffuser }
    mov  bl, [ScrSnow] { on fait cela car }
                       { DS devient une fausse base! }
    cld
    lds  si, [Texte]   { pointeur texte }
    lodsb              { prend longueur de chaine }
    mov  bh, al        { BL=longueur de chaine }
    mov  dx, VIDEOSTAT
@@BOUCLE:
    or   bh, bh        { reste rien a lire? }
    jz   @@FIN         { oui }
    dec  bh
    lodsb
    PUSH AX
    CALL Ascii2Mat
@@SUIV:
    or   bl, bl        { neige? }
    jz   @@CONT        { non! }
    mov  ch, al        { sauve }
@@CF1:
    IN   AL, DX
    RCR  AL, 1
    JC   @@CF1
@@CF0:
    IN   AL, DX
    RCR  AL, 1
    JNC  @@CF0
    mov  al, ch        { restore }
@@CONT:
    stosw              { ax->ecran }
    dec  cl
    or   cl, cl
    jnz  @@BOUCLE
@@FIN:
    POP  AX             { RESTORE AX }
@@FIN_2:
    pop     ds
End;


Procedure WrtScr(texte : string; X,Y,Att : byte);
Var decal : Word;
    w     : ^Word;
    len   : Word;
    i     : Word;
Begin
 decal := _WrtScr_(texte,X,Y,Att);
 if (Video640) Then
  Begin
   w := Ptr(_VExt_,decal);
   len := Length(texte);
   For i := 1 To len Do
    Begin
     w^ := 0;
     Inc(Word(w),2);
    End;
   Wrt640(decal,X,Y,len);
   If (_VCurY_=y) And (x<=_VCurX_) And (_VCurX_<(x+Len)) Then Cur640(TRUE);
  End;
End;


procedure FromScr(dest : pointer; x,y,lg : byte); Assembler;
Asm
    push ds

    MOV  BL, [x]
    CMP  BL, 80
    JAE  @@FIN
    MOV  AL, [y]
    CMP  AL, [ScreenHt]
    JAE  @@FIN

    XOR  AH, AH
    MOV  DX, AX
    MOV  CL, 6
    SHL  AX, CL
    MOV  CL, 4
    SHL  DX, CL
    ADD  AX, DX

    XOR  BH, BH
    ADD  AX, BX
    SHL  AX, 1

    PUSH AX     { sauve l'offset }
    (*
    MOV  ES, [ScreenSeg]
    *)

    mov  cl, [Lg]      { lg }
    xor  ch, ch        { cx = lg }

    mov  bl, [X]
    xor  bh, bh        { bx = x }
    add  bx, cx        { lg+x ->bx }
    cmp  bx, 80
    jbe  @@OK
    { une correction de lg est necessaire }
    mov  cl, 80
    sub  cl, [X]
    xor  ch, ch
@@OK:
    jcxz @@FIN
    mov  bl, [ScrSnow] { l'etat neige en BL }
    les  di, [Dest]    { adr texte destination }
    POP  SI
(*
    CMP  [VideoEGA], FALSE
    JE   @NOEGA
    MOV  DS, [EgaSeg]
    JMP  @JUSTDOIT        { DS:SI designe la RAM, copie EGA }
@NOEGA:
*)
    MOV  DS, [ScreenSeg]  { DS:SI designe l'ecran }
(*
@JUSTDOIT:
*)
    mov  dx, VIDEOSTAT
    cld
@@SUIV:
    { saisie d'un car+attrib de l'ecran }
    or   bl, bl
    jz   @@FROMSCR       { pas de neige }
@@CF1:
    IN   AL, DX
    RCR  AL, 1
    JC   @@CF1
@@CF0:
    IN   AL, DX
    RCR  AL, 1
    JNC  @@CF0
@@FROMSCR:
    lodsw
    or   ah, 128         { bit7=1 origine RAM Video }
    stosw
    loop @@SUIV
@@FIN:
    pop     ds
End;


Function _ToScr_(source : pointer; x,y,lg : byte) : Word; Assembler;
Asm
    push ds

    MOV  BL, [x]
    CMP  BL, 80
    JAE  @@FIN_X
    MOV  AL, [y]
    CMP  AL, [ScreenHt]
    JB   @@CONT_X
@@FIN_X:
    XOR  AX, AX
    JMP  @@FIN_NONE
@@CONT_X:
    XOR  AH, AH
    MOV  DX, AX
    MOV  CL, 6
    SHL  AX, CL
    MOV  CL, 4
    SHL  DX, CL
    ADD  AX, DX

    XOR  BH, BH
    ADD  AX, BX
    SHL  AX, 1

    MOV  DI, AX
    PUSH AX             { SAUVE AX }
    MOV  ES, [ScreenSeg]

    mov  cl, [Lg]      { lg }
    xor  ch, ch        { cx = lg }

    mov  al, [X]       { x }
    mov  bl, al
    xor  bh, bh        { bx = x }
    add  bx, cx        { lg+x ->bx }
    cmp  bx, 80
    jb   @@OK
    { une correction de lg est necessaire }
    mov  cl, 80
    sub  cl, al
    xor  ch, ch
@@OK:
    jcxz @@FIN
    mov  bl, [ScrSnow] { neige en BL }

    lds  si, [Source]  { pointe sur le texte DS FAUX! }
    mov  dx, VIDEOSTAT
    cld
@@SUIV:
    { saisie d'un car+attrib du texte }
    lodsw
    PUSH AX
    CALL Ascii2Mat
    or   bl, bl
    jz   @@TOSCR { pas de neige }
    mov  bh, al        { sauve AL }
@@CF1:
    IN   AL, DX
    RCR  AL, 1
    JC   @@CF1
@@CF0:
    IN   AL, DX
    RCR  AL, 1
    JNC  @@CF0
    mov al, bh        { restore AL }
@@TOSCR:
    stosw
    loop @@SUIV
@@FIN:
    POP  AX           { RESTORE AX }
@@FIN_NONE:
    pop  ds
End;


procedure R_ToScr(source : pointer; x,y,lg : byte);
Var decal : Word;
Begin
 decal := _ToScr_(source,x,y,lg);
 If (Video640) Then
  Begin
   Wrt640(decal,x,y,lg);
   If (_VCurY_=y) And (x<=_VCurX_) And (_VCurX_<(x+lg)) Then Cur640(TRUE);
  End;
End;


procedure ToScr(source : pointer; x,y,lg : byte);
Var w : ^Word;
    decal : Word;
    i : Word;
Begin
 decal := _ToScr_(source,x,y,lg);
 If (Video640) Then
  Begin
   w := Ptr(_VExt_,decal);
   For i := 1 To lg Do
    Begin
     w^ := 0;           { RAZ... }
     Inc(Word(w),2);
    End;
   Wrt640(decal,x,y,lg);
   If (_VCurY_=y) And (x<=_VCurX_) And (_VCurX_<(x+lg)) Then Cur640(TRUE);
  End;
End;


procedure RbtXY(var X,Y : byte);
begin
  if X>79 then X := 79;
  if Y>=ScreenHt then Y := ScreenHt-1;
end;

procedure FillWord(var source; Lg,Data : word);
begin
  inline($06/$C4/$BE/ source /$8B/$8E/ Lg /$8B/$86/ Data /
         $E3/$03/$FC/$F3/$AB/$07 );
end;

procedure RbtZn(var Zn : Zn_Rec);
begin
  with Zn do
    begin
      RbtXY(X,Y);
      if (X+Lg)>80 then Lg := 80-X;
      if (Y+Ht)>ScreenHt then Ht := ScreenHt-Y;
    end;
end;

procedure RbtZc(var x,y,lg,ht : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  RbtZn(Zn);
  x := Zn.x;
  y := Zn.y;
  lg := Zn.lg;
  ht := Zn.ht;
end;

procedure FillZn(Zn : Zn_Rec; Car,Att : byte);
var Line  : array[0..79] of DtScr_Rec;
    Temp  : DtScr_Rec;
    Index : byte;
    AdrExt : Pointer;
    ExtScr : ^MemScr_Map;   { extension... }
begin
  RbtZn(Zn);
  Temp.Car := Car;
  Temp.Att := Att;
  FillWord(Line[Zn.X],Zn.Lg,Temp.Dt);
  for Index := Zn.Y to Zn.Y+Zn.Ht-1 do
    ToScr(@Line[Zn.X],Zn.X,Index,Zn.Lg);
end;

procedure FillZc(x,y,lg,ht,Car,Att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  FillZn(Zn,Car,Att);
end;

procedure ClrZn(Zn : Zn_Rec; Att : byte);
begin
  FillZn(Zn,32,Att);
end;

procedure ClrZc(x,y,lg,ht,Att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  ClrZn(Zn,Att);
end;

procedure CdrZn( Zn : Zn_Rec; Cdr : cadre; att : byte);
var texte : string[80];
    i : byte;
begin
  RbtZn(Zn);
  if (Zn.Lg>1) and (Zn.Ht>1) then
    begin
      texte[1] := cdr.hg;
      FillChar(texte[2],Zn.Lg-2,cdr.hh);
      texte[Zn.Lg] := cdr.hd;
      texte[0] := char(Zn.Lg);
      WrtScr(texte,Zn.X,Zn.Y,att);
      texte[1] := cdr.bg;
      FillChar(texte[2],Zn.Lg-2,cdr.bh);
      texte[Zn.Lg] := cdr.bd;
      texte[0] := char(Zn.Lg);
      WrtScr(texte,Zn.X,Zn.Y+Zn.Ht-1,att);
      for i := 1 to Zn.Ht-2 do
        begin
          WrtDt(byte(cdr.vg),Zn.X,Zn.Y+i,att);
          WrtDt(byte(cdr.vd),Zn.X+Zn.Lg-1,Zn.Y+i,att);
        end;
    end;
end;

procedure CdrZc( x,y,lg,ht : byte; Cdr : cadre; att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  CdrZn(Zn,Cdr,att);
end;

procedure CCdrZn(Zn : Zn_Rec; style : byte; att : byte);
begin
  CdrZn(Zn,cdrtab[style],att);
end;

procedure CCdrZc(x,y,lg,ht : byte; style : byte; att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  CdrZn(Zn,cdrtab[style],att);
end;

procedure AspZn(Zn : Zn_Rec; Att : byte);
var line : array[1..80] of DtScr_Rec;
    i : byte;
    l : byte;
begin
  RbtZn(Zn);
  for l := Zn.Y to Zn.Y+Zn.Ht-1 do
    begin
      FromScr(@line,Zn.x,l,Zn.Lg);
      If VideoEGA Then
       for i := 1 to Zn.Lg do line[i].att := att Or (line[i].att And (128+8))
      Else for i := 1 to Zn.Lg do line[i].att := att;
      R_ToScr(@line,Zn.X,l,Zn.Lg);
    end;
end;

procedure AspZc(x,y,lg,ht : byte; Att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  AspZn(Zn,Att);
end;

Procedure VGAMove( col : Byte; y : Word; NbCol : Byte; Nby : Word;
                   colDest : Byte; yDest : Word ); Assembler;
Var ReadOfs : Word;
    WriteOfs: Word;
    Up      : Boolean;   { Sens de copie (suivant y<=>yDest) }
Asm
    PUSH DS
    PUSH ES

    CLD

    MOV  AX, 0A000h
    MOV  DS, AX
    MOV  ES, AX

    MOV  CL, 6           { y*80 ... }
    MOV  AX, [y]
    CMP  AX, [yDest]
    JAE  @01
    { la zone descend, donc Up=FALSE }
    MOV  [Up], FALSE
    ADD  AX, [Nby]
    DEC  AX
    JMP  @02
@01:
    { La zone monte, donc Up=TRUE }
    MOV  [Up], TRUE
@02:

    MOV  DX, AX
    SHL  AX, CL
    MOV  CL, 4
    SHL  DX, CL
    ADD  AX, DX          { dans AX }

    ADD  AL, [col]
    ADC  AH, 0
    MOV  [ReadOfs], AX

    MOV  CL, 6
    MOV  AX, [yDest]
    CMP  [Up], FALSE
    JNE  @03
    { la zone descend }
    ADD  AX, [Nby]
    DEC  AX
@03:
    MOV  DX, AX
    SHL  AX, CL
    MOV  CL, 4
    SHL  DX, CL
    ADD  AX, DX          { dans AX }

    ADD  AL, [colDest]
    ADC  AH, 0
    MOV  [WriteOfs], AX



    MOV  BH, [NbCol]     { c + rapide ainsi... }

    MOV  DX, 3CEh

    MOV  AX, 0105h       { mode Read 0, Write 1 }
    OUT  DX, AX

@BOUCLE:
    MOV  SI, [ReadOfs]
    MOV  DI, [WriteOfs]

    MOV  CL, BH
    XOR  CH, CH

    REP  MOVSB

    CMP  [Up], FALSE
    JE   @04
    ADD  [ReadOfs], 80
    ADD  [WriteOfs], 80
    JMP  @05
@04:
    SUB  [ReadOfs], 80
    SUB  [WriteOfs], 80
@05:
    DEC  [Nby]
    JNZ  @BOUCLE

    POP  ES
    POP  DS
End;




procedure ZnUp(Zn : Zn_Rec; LineUp,Att : byte);
var Temp  : DtScr_Rec;
    i     : Byte;
    MemScr   : ^MemScr_Map; { ecran actif      }
    ExtScr   : ^MemScr_Map; { Extension... }
begin
  RbtZn(Zn);

  If Video640 Then
   Begin
    Cur640(FALSE);
    MemScr := Ptr(ScreenSeg,0);
    ExtScr := Ptr(_VExt_,0);

    If (LineUp=0) Or (LineUp>Zn.Ht) Then LineUp := Zn.Ht;

    If LineUp<Zn.Ht Then
     Begin
      For i := LineUp To Zn.Ht-1 Do
       Begin
        Move(MemScr^[Zn.Y+i,Zn.X],
             MemScr^[Zn.Y+(i-LineUp),Zn.X],Zn.Lg*2);
        Move(ExtScr^[Zn.Y+i,Zn.X],
             ExtScr^[Zn.Y+(i-LineUp),Zn.X],Zn.Lg*2);
       End;
     End;

    Temp.Car := Byte(' ');
    Temp.Att := Att;
    For i := Zn.Ht-LineUp To Zn.Ht-1 Do
     Begin
      FillWord(MemScr^[Zn.Y+i,Zn.X],Zn.Lg,Temp.Dt);
      FillWord(ExtScr^[Zn.Y+i,Zn.X],Zn.Lg,$0000);
     End;

    VGAMove(Zn.X,(Zn.Y+1)*10,Zn.Lg,(Zn.Ht-LineUp)*10,Zn.X,(Zn.Y+1-LineUp)*10);
    Cur640(TRUE);
   End
  Else
   Begin
    Asm
        MOV  AH, $06
        MOV  AL, [LineUp]
        MOV  CH, [Zn.Y]
        MOV  CL, [Zn.X]
        MOV  DH, [Zn.Y]
        ADD  DH, [Zn.Ht]
        DEC  DH
        MOV  DL, [Zn.X]
        ADD  DL, [Zn.Lg]
        DEC  DL
        MOV  BH, [Att]
        INT  INTVIDEO
    End;
   End;
end;

procedure ZcUp(x,y,lg,ht : byte; LineUp,Att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  ZnUp(Zn,LineUp,Att);
end;

procedure ZnDn(Zn : Zn_Rec; LineDn,Att : byte);
var Temp  : DtScr_Rec;
    i     : Byte;
    MemScr   : ^MemScr_Map; { ecran actif      }
    ExtScr : ^MemScr_Map;   { extension... }
begin
  RbtZn(Zn);

  If Video640 Then
   Begin
    Cur640(FALSE);
    MemScr := Ptr(ScreenSeg,0);
    ExtScr := Ptr(_VExt_,0);

    If (LineDn=0) Or (LineDn>Zn.Ht) Then LineDn := Zn.Ht;

    If LineDn<Zn.Ht Then
     Begin
      For i := Zn.Ht-1 Downto LineDn Do
       Begin
        Move(MemScr^[Zn.Y+(i-LineDn),Zn.X],
             MemScr^[Zn.Y+i,Zn.X],Zn.Lg*2);
        Move(ExtScr^[Zn.Y+(i-LineDn),Zn.X],
             ExtScr^[Zn.Y+i,Zn.X],Zn.Lg*2);
       End;
     End;

    Temp.Car := Byte(' ');
    Temp.Att := Att;
    For i := 0 To LineDn-1 Do
     Begin
      FillWord(MemScr^[Zn.Y+i,Zn.X],Zn.Lg,Temp.Dt);
      FillWord(ExtScr^[Zn.Y+i,Zn.X],Zn.Lg,$0000);
     End;

    VGAMove(Zn.X,Zn.Y*10,Zn.Lg,(Zn.Ht-LineDn)*10,Zn.X,Zn.Y*10+LineDn*10);
    Cur640(TRUE);
   End
  Else
   Begin
    Asm
        MOV  AH, $07
        MOV  AL, [LineDn]
        MOV  CH, [Zn.Y]
        MOV  CL, [Zn.X]
        MOV  DH, [Zn.Y]
        ADD  DH, [Zn.Ht]
        DEC  DH
        MOV  DL, [Zn.X]
        ADD  DL, [Zn.Lg]
        DEC  DL
        MOV  BH, [Att]
        INT  INTVIDEO
    End;
   End;
end;


procedure ZcDn(x,y,lg,ht : byte; LineDn,Att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  ZnDn(Zn,LineDn,Att);
end;

procedure CurXY(X,Y : byte);
var Reg : registers;
begin
  RbtXY(X,Y);
  If Video640 And ( (_VCurX_<>X) Or (_VCurY_<>Y) ) Then
   Begin
    Cur640(FALSE);
    _VCurX_ := X;
    _VCurY_ := Y;
    Cur640(TRUE);
   End
  Else
   Begin
    Reg.AH := $02;
    Reg.DH := Y;
    Reg.DL := X;
    Reg.BH := 0;
    Intr($10,Reg);
   End;
end;

(*
procedure CurFormat(Deb,Fin : byte);
var Reg : registers;
begin
  Reg.AH := $01;
  Reg.CH := Deb and 31;
  Reg.CL := Fin and 31;
  Intr($10,Reg);
end;
*)

function GetVideoMode : byte;
var Reg : registers;
begin
  Reg.AH := $0F;
  Intr($10,Reg);
  GetVideoMode := Reg.AL;
end;

procedure SetVideoMode(what : byte);
var Reg : registers;
begin
  Reg.AX := what;
  Intr($10,Reg);
(*
  Reg.AH := $01;
  Reg.CH := 0;
  Reg.CL := 31;
  Intr($10,Reg);
*)
end;

const NoCarte   = 0;
      Mono40x25 = 1;
      Coul80x25 = 2;
      Mono80x25 = 3;

const Mono = 7; (* Mono *)
      C80  = 3; (* Coul80x25 *)

function GetVideoCarte : byte;
var Reg : registers;
begin
  Intr($11,Reg);
  GetVideoCarte := (Reg.AL and (16+32)) shr 4;
end;

function GetAdrScr : pointer;
begin
  if GetVideoCarte=Coul80x25 then GetAdrScr := ptr($B800,$0000)
  else GetAdrScr := ptr($B000,$0000)
end;

function GetBestVideoMode : byte;
begin
  if GetVideoCarte=Coul80x25 then GetBestVideoMode := C80
  else GetBestVideoMode := Mono;
end;

(**** PILE_ZN ****)

Type PtrRec = Record Ofs, Seg : Word; End;

     PPileZnRec = ^PileZnRec;

     PileZnRec = Record
       Zn   : Zn_Rec;
       Adr  : Pointer;
       AdrExt : Pointer;        { zone extension pour mode 640... }
       Next : PPileZnRec;
      End;

Var FirstPileZn : PPileZnRec;
    LastPileZn  : PPileZnRec;

procedure PushZn(Zn : Zn_Rec);
(* sauvegarde une zone de l'ecran sur une pile *)
var Line : Byte;
    Adr  : Pointer;
    AdrExt : ^Pointer;
    ExtScr : ^MemScr_Map;   { extension... }
    z    : PPileZnRec;
begin
 New(z);
 If z<>NIL Then
  Begin

   RbtZn(Zn);
   GetMem(Adr,Zn.Ht*Zn.Lg*2);
   If Adr<>NIL Then
    Begin

     If Video640 Then
      Begin
       GetMem(AdrExt,Zn.Ht*Zn.Lg*2);
       ExtScr := Ptr(_VExt_,0);
      End
     Else AdrExt := Nil;

     for Line := Zn.Y to Zn.Y+Zn.Ht-1 do
      Begin
       FromScr(Ptr(PtrRec(Adr).Seg,PtrRec(Adr).Ofs+(Line-Zn.Y)*(Zn.Lg*2)),
               Zn.x,Line,Zn.Lg);
       If (AdrExt<>NIL) Then
        Begin
         Move(ExtScr^[Line,Zn.x],Ptr(PtrRec(AdrExt).Seg,PtrRec(AdrExt).Ofs+(Line-Zn.Y)*(Zn.Lg*2))^,Zn.Lg*2);
        End;
      End;

     If FirstPileZn=NIL Then FirstPileZn := z
     Else LastPileZn^.Next := z;

     LastPileZn := z;

     z^.Zn   := Zn;
     z^.Adr  := Adr;
     z^.AdrExt := AdrExt;
     z^.Next := NIL;

     Exit;

    End;

   Dispose(z);
  End;
end;


procedure PushZc(x,y,lg,ht : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  PushZn(Zn);
end;

procedure PopZn;
(* restitue la premiere fenetre de la pile *)
var Line : byte;
    ADer : PPileZnRec;
    z    : PPileZnRec;
    AdrExt : Pointer;
    ExtScr : ^MemScr_Map;   { extension... }
begin
  z := FirstPileZn;
  If z<>NIL Then
   Begin

    ADer := NIL;
    While z^.Next<>NIL Do
     Begin
      ADer := z;
      z := z^.Next;
     End;

    AdrExt := z^.AdrExt;
    ExtScr := Ptr(_VExt_,0);

    for Line := z^.Zn.Y to z^.Zn.Y+z^.Zn.Ht-1 do
     Begin
      If (AdrExt<>NIL) Then
       Begin
        Move(Ptr(PtrRec(AdrExt).Seg,PtrRec(AdrExt).Ofs+(Line-z^.Zn.Y)*(z^.Zn.Lg*2))^,ExtScr^[Line,z^.Zn.x],z^.Zn.Lg*2);
       End;
      R_ToScr(ptr(PtrRec(z^.Adr).Seg,PtrRec(z^.Adr).Ofs+(Line-z^.Zn.Y)*(z^.Zn.Lg*2)),
              z^.Zn.X,Line,z^.Zn.Lg);
     End;

    If (AdrExt<>NIL) Then FreeMem(AdrExt,z^.Zn.Ht*z^.Zn.Lg*2);
    FreeMem(z^.Adr,z^.Zn.Ht*z^.Zn.Lg*2);

    Dispose(z);

    If ADer=NIL Then FirstPileZn := NIL
    Else ADer^.Next := NIL;
    LastPileZn := ADer;

   End;
end;

procedure PopNoZn;
(* supprime la premiere fenetre de la pile *)
var ADer : PPileZnRec;
    z    : PPileZnRec;
begin
  z := FirstPileZn;
  If z<>NIL Then
   Begin

    ADer := NIL;
    While z^.Next<>NIL Do
     Begin
      ADer := z;
      z := z^.Next;
     End;

    FreeMem(z^.Adr,z^.Zn.Ht*z^.Zn.Lg*2);

    Dispose(z);

    If ADer=NIL Then FirstPileZn := NIL
    Else ADer^.Next := NIL;
    LastPileZn := ADer;

   End;
end;

function FirstFileZn(open : boolean) : byte;
(* retourne le numero du premier fichier ouvert ou ferme rencontre *)
(* si 0 alors aucun fichier correspond *)
var NumFich : byte;
begin
  for NumFich := 1 to MX_FILE_ZN do
    if open=FileZn[NumFich].open then
      begin
        FirstFileZn := NumFich;
        exit;
      end;
  FirstFileZn := 0; (* rien trouve!! *)
end;

procedure CloseZn(NumFich : byte);
begin
  if FileZn[NumFich].open then
    begin
      If (FileZn[NumFich].AdrExt<>NIL) Then FreeMem(FileZn[NumFich].adrExt,FileZn[NumFich].Zn.ht*FileZn[NumFich].Zn.lg*2);
      FreeMem(FileZn[NumFich].adr,
              FileZn[NumFich].Zn.ht*FileZn[NumFich].Zn.lg*2);
      FileZn[NumFich].open := false;
    end;
end;

function SaveZn(Zn : Zn_Rec) : byte;
(* sauvegarde la portion d'ecran designe dans un pseudo fichier *)
var line : byte;
    NumFich : byte;
    AdrExt : Pointer;
    ExtScr : ^MemScr_Map;   { extension... }
begin
  NumFich := FirstFileZn(false);
  if NumFich>0 then
    begin
      FileZn[NumFich].open := true;
      RbtZn(Zn);
      FileZn[NumFich].Zn := Zn;
      GetMem(FileZn[NumFich].Adr,Zn.Ht*Zn.Lg*2);
      AdrExt := Nil;
      If (Video640) Then
       Begin
        GetMem(AdrExt,Zn.Ht*Zn.Lg*2);
        FileZn[NumFich].AdrExt := AdrExt;
        ExtScr := Ptr(_VExt_,0);
       End
      Else AdrExt := Nil;
      for line := Zn.Y to Zn.Y+Zn.Ht-1 do
       Begin
        FromScr(ptr(FileZn[NumFich].Seg,
                FileZn[NumFich].Ofs+(Line-Zn.Y)*(Zn.Lg*2)),
                Zn.X, Line,Zn.Lg);
        If (AdrExt<>NIL) Then
         Begin
          Move(ExtScr^[Line,Zn.x],Ptr(PtrRec(AdrExt).Seg,PtrRec(AdrExt).Ofs+(Line-Zn.Y)*(Zn.Lg*2))^,Zn.Lg*2);
         End;
       End;
    end;
  SaveZn := NumFich;
end;

function SaveZc(x,y,lg,ht : byte) : byte;
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  SaveZc := SaveZn(Zn);
end;

procedure RstZn(NumFich : byte);
(* reaffiche la portion d'ecran sauve par SaveZn *)
(* le fichier n'est pas clos! *)
var Line : byte;
    Zn : Zn_Rec;
    AdrExt : Pointer;
    ExtScr : ^MemScr_Map;   { extension... }
begin
  if FileZn[NumFich].open then
    begin
      Zn := FileZn[NumFich].Zn;
      AdrExt := FileZn[NumFich].AdrExt;
      ExtScr := Ptr(_VExt_,0);
      for Line := Zn.Y to Zn.Y+Zn.Ht-1 do
       Begin
        If (AdrExt<>NIL) Then
         Begin
          Move(Ptr(PtrRec(AdrExt).Seg,PtrRec(AdrExt).Ofs+(Line-Zn.Y)*(Zn.Lg*2))^,ExtScr^[Line,Zn.x],Zn.Lg*2);
         End;
        R_ToScr(ptr(FileZn[NumFich].Seg,
                    FileZn[NumFich].Ofs+(Line-Zn.Y)*(Zn.Lg*2)),
                Zn.X,Line,Zn.Lg);
       End;
    end;
end;

procedure RstZnTo(NumFich,x,y : byte);
var Zn,cpZn : Zn_Rec;
    Line : byte;
    AdrExt : Pointer;
    ExtScr : ^MemScr_Map;   { extension... }
begin
  if FileZn[NumFich].open then
    begin
      Zn := FileZn[NumFich].Zn;
      Zn.X := x;
      Zn.Y := y;
      cpZn := Zn;
      RbtZn(Zn);
      AdrExt := FileZn[NumFich].AdrExt;
      ExtScr := Ptr(_VExt_,0);
      if (cpZn.X=Zn.X) and (cpZn.Y=Zn.Y) and (cpZn.Lg=Zn.Lg) and
         (cpZn.Ht=Zn.Ht) then
        for Line := Zn.Y to Zn.Y+Zn.Ht-1 do
         Begin
          If (AdrExt<>NIL) Then
           Begin
            Move(Ptr(PtrRec(AdrExt).Seg,PtrRec(AdrExt).Ofs+(Line-Zn.Y)*(Zn.Lg*2))^,ExtScr^[Line,Zn.x],Zn.Lg*2);
           End;
          R_ToScr(ptr(FileZn[NumFich].Seg,
                      FileZn[NumFich].Ofs+(Line-Zn.Y)*(Zn.Lg*2)),
                  Zn.X,Line,Zn.Lg);
         End;
    end;
end;

(****************************)
(*            WIND          *)
(****************************)

procedure DessWd( Zn : Zn_Rec; ZAtt,style,CAtt : byte);
begin
  FillZn(Zn,32,ZAtt);
  CdrZn(Zn,CdrTab[style],CAtt);
end;

procedure DessWc(x,y,lg,ht : byte; ZAtt,style,CAtt : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  DessWd(Zn,ZAtt,style,CAtt);
end;

procedure PushWd( Zn : Zn_Rec; ZAtt,style,CAtt : byte);
begin
  PushZn(Zn);
  DessWd(Zn,ZAtt,style,CAtt);
end;

procedure PushWc(x,y,lg,ht : byte; ZAtt,style,CAtt : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  PushZn(Zn);
  DessWd(Zn,ZAtt,style,CAtt);
end;

procedure PopWd;
begin
  PopZn;
end;

(*
Procedure CurOFF; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    MOV  AH, 01h
    AND  CH, 10011111b    { bit 5-6  00 }
    OR   CH, 00100000b    { bit 5-6 = 01 => invisible }
    INT  INTVIDEO
End;


Procedure CurON; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    MOV  AH, 01h
    AND  CH, 10011111b    { bit 5-6  00 }
    INT  INTVIDEO
End;


Procedure CurSmall; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    AND  CH, 11100000b    { garder bit5  7 }
    AND  CL, 11100000b
    CMP  [VideoMode], VMODE_MDA
    JNE  @ICI
    OR   CH, 11           { ligne de debut }
    OR   CL, 12           { ligne fin }
    JMP  @SETCUR
@ICI:
    OR   CH, 6            { ligne de debut }
    OR   CL, 7            { ligne fin }
@SETCUR:
    MOV  AH, 01h
    INT  INTVIDEO
End;
*)

Procedure CurMonoBig; Assembler;
Asm
    MOV  AH, 01h
    MOV  CH, 0            { ligne de debut }
    MOV  CL, 15 { 13 }           { ligne fin }
    INT  INTVIDEO
End;


Procedure CurCGABig; Assembler;
Asm
    MOV  AH, 01h
    MOV  CH, 0            { ligne de debut }
    MOV  CL, 15           { ligne fin }
    INT  INTVIDEO
End;



Procedure _CurPos_( column, row : Byte ); Assembler;
Asm
    MOV  AH, 02h
    MOV  DL, column
    MOV  DH, row
    XOR  BH, BH
    INT  INTVIDEO
End;

Procedure CurPos( column, row : Byte );
Begin
 If Video640 And ( (_VCurX_<>column) Or (_VCurY_<>row) ) Then
  Begin
   Cur640(FALSE);
   _VCurX_ := column;
   _VCurY_ := row;
   Cur640(TRUE);
  End
 Else _CurPos_(column,row);
End;


Procedure Reset_640; Assembler;
Asm
 mov al, $10
 xor ah, ah
 int INTVIDEO
End;


Procedure ResetVideoEGA;
Begin
 LoadMatrice(JeuG2B,LgG2B,0,MatG2B);
 LoadMatrice(JeuGPlus,LgGPlus,0,MatGPlus);
 LoadMatrice(JeuG0,LgG0,0,MatG0);
 LoadMatrice(JeuG2,LgG2,0,MatG2);
 LoadMatrice(JeuGPlus2,LgGPlus2,0,MatGPlus2);

 LoadMatriceG1Joint;
 LoadMatriceG1Disjoint;
 LoadMatrice(JeuGIbm,LgGIbm,1,MatGIbm);

 If (Video640) Then Reset_640
 Else ResetCRTC_EGA;
 ResetPalette;
End;


Function SetVideoModeEGA( Grey, EGALight : Boolean ) : Word;
Type PtrRec = Record Ofs, Seg : Word; End;
var vgaseg : Word;
    extseg : Word;
Begin
 If Video640 Then
  Begin

   GetMem(_VirtualScreen_,(80*35*2)+15);
   GetMem(_VirtualExt_,(80*35*2)+15);
   GetMem(_VirtualMatrice_,(512*10));

   vgaseg := PtrRec(_VirtualScreen_).Seg;
   If PtrRec(_VirtualScreen_).Ofs<>0 Then Inc(vgaseg);

   FillWord(Ptr(vgaseg,0)^,80*35*2,$0720);

   extseg := PtrRec(_VirtualExt_).Seg;
   If PtrRec(_VirtualExt_).Ofs<>0 Then Inc(extseg);

   FillWord(Ptr(extseg,0)^,80*35*2,$0000);

   SetVideoModeEGA := vgaseg;
   _VExt_  := extseg;
   _VCurX_ := 0;
   _VCurY_ := 0;
   _VCurFlash_ := TRUE;
   _VCurFlash_C18 := -1;
   MasqueCurseur  := FALSE;
  End
 Else
  Begin
   OpenVideoEGA;
   SetVideoModeEGA := $B800;
  End;

 VideoGrey := Grey;
 VideoEGALight := EGALight;

 ResetVideoEGA;

End;


Var SaveExitProc : Pointer;

procedure CloseVideoSys;
var index : byte;
begin
  ExitProc := SaveExitProc;

  While (FirstPileZn<>NIL) do PopNoZn;

  for index := 1 to MX_FILE_ZN do
    if FileZn[index].open then CloseZn(index);

  If VideoMode=VMODE_EGA Then
   Begin
    If Video640 Then
     Begin
      FreeMem(_VirtualMatrice_,512*10);
      FreeMem(_VirtualExt_,80*35*2+15);
      FreeMem(_VirtualScreen_,80*35*2+15);
      SetVideoMode(LastVideoMode);
     End
    Else CloseVideoEGA;
   End
  Else SetVideoMode(LastVideoMode);
end;


Procedure MyExit; Far;
Begin
 CloseVideoSys;
End;

Function OpenVideoSys( VMode : Byte; neige, Grey, EGALight : boolean ) : Byte;
var index : byte;
    adr : Word;
    Conf: Word;
begin
  SaveExitProc := ExitProc;
  ExitProc := @MyExit;

  VideoEGA := FALSE;
  VideoVGA := FALSE;
  Video640 := FALSE;
  CurrentDevMat := Nil;

  LastVideoMode := GetVideoMode;

  If VMode=VMODE_UNDEF Then
   Begin
    Asm
        INT 011h
        MOV [Conf], AX
    End;

    If Conf And 48=48 Then VideoMode := VMODE_MDA
    Else
     Begin { CGA ou VGA ? }
      Asm
          MOV  AX, 1A00h
          INT  INTVIDEO
          MOV  [BYTE PTR Conf], AL
      End;
      If Byte(Conf)=$1A Then
       Begin
        VideoMode := VMODE_EGA;
        VideoVGA  := TRUE;
        Video640  := FALSE;
       End
      Else
       Begin { CGA ou EGA ? }
        Asm
            MOV  AH, 12h
            MOV  BL, 10h
            INT  INTVIDEO
            MOV  [BYTE PTR Conf], BL
        End;
        If Byte(Conf)<>$10 Then
         Begin
          VideoMode := VMODE_EGA;
          VideoVGA  := FALSE;
          Video640  := FALSE;
         End
        Else VideoMode := VMODE_CGA;
       End;

     End;
   End
  Else
   If VMode=VMODE_MDA Then VideoMode := VMODE_MDA
   Else
    If VMode=VMODE_CGA Then VideoMode := VMODE_CGA
    Else
     Begin
      VideoMode := VMODE_EGA;
      VideoVGA := (VMode=VMODE_VGA) Or (VMode=VMODE_640);
      Video640 := VMode=VMODE_640;
     End;

  If VideoMode=VMODE_MDA Then
   Begin
    SetVideoMode(MONO);
    CurMonoBig;

    ScrSnow := FALSE;
    adr     := $B000;
    ScreenHt    := 25;
   End
  Else
   If VideoMode=VMODE_CGA Then
    Begin
     SetVideoMode(C80);
     CurCGABig;
     ScrSnow := Neige;
     adr     := $B800;
     ScreenHt    := 25;
    End
   Else
    Begin
     adr := SetVideoModeEGA(Grey,EGALight);
     VideoEga := TRUE;
     ScrSnow := FALSE;
     ScreenHt    := 35;
    End;

  ScreenSeg := adr;

  While (FirstPileZn<>NIL) do PopNoZn;

  for index := 1 to MX_FILE_ZN do FileZn[index].open := false;

  OpenVideoSys := VideoMode;
end;


Procedure KeepVideo;
Begin
 PushZc(0,0,80,ScreenHt);
 If VideoMode=VMODE_EGA Then
  Begin
   If Video640 Then
    Begin
     FreeMem(_VirtualMatrice_,512*10);
     FreeMem(_VirtualExt_,80*35*2+15);
     FreeMem(_VirtualScreen_,80*35*2+15);
     SetVideoMode(LastVideoMode);
    End
   Else CloseVideoEGA;
  End
 Else SetVideoMode(LastVideoMode);
End;


Procedure ResumeVideo(Grey, EGALight : Boolean);
Begin
 If VideoMode=VMODE_MDA Then
  Begin
   SetVideoMode(MONO);
   CurMonoBig;
  End
 Else
  If VideoMode=VMODE_CGA Then
   Begin
    SetVideoMode(C80);
    CurCGABig;
   End
  Else ScreenSeg := SetVideoModeEGA(Grey,EGALight);
 PopZn;
End;


Begin
  FirstPileZn := NIL;
  LastPileZn  := NIL;
  VideoReset.Ptr := NIL;
End.
